﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework;

namespace DataModel
{
    public class Animation
    {
        public string Name { get; set; }
        public string Asset { get; set; }
        public List<Frame> Frames { get; set; }
        [ContentSerializerIgnore]
        public Frame CurrentFrame { get { return Frames[frameIndex]; } }

        private TimeSpan time;
        private int frameIndex = 0;

        public Animation()
        {
            Frames = new List<Frame>();
        }

        public void Reset()
        {
            time = TimeSpan.Zero;
            frameIndex = 0;
        }

        public void Update(GameTime gameTime)
        {
            time += gameTime.ElapsedGameTime;

            if (time > CurrentFrame.Duration)
            {
                frameIndex++;
                if (frameIndex >= Frames.Count)
                    frameIndex = 0;
                time = TimeSpan.Zero;
            }
        }
    }
}
